 
FUNCTION CANTHIJOS(X)
*
*Cantidad de Hijos del Trabajador
*Autor: CASA MATRIZ
*Fecha de creacin: 20020912
*Ultima actualizacin: 20020912
*------------------------------------------------------------------------------------
SELECT trabajad
SET order to tag cod_trab
SEEK qtrabajadores.cod_trab
IF found()
	RETURN(trabajad.hijos)
ELSE
	RETURN(0)
ENDIF
ENDFUNC
*************************************************************************************
 
 
FUNCTION DIASFERIADOS(fecha_inicio,fecha_fin)
*Intervalo a evaluar
*Cantidad de Dias Feriados o No Lab.
*Autor: CASA MATRIZ
*Fecha de creacin: 20020928
*Ultima actualizacin: 20020928
*------------------------------------------------------------------------------------
SELECT calendario
		COUNT FOR calendario.fecha>=fecha_inicio AND calendario.fecha<=fecha_fin to  xdiasnolab
		return(xdiasnolab)

ENDFUNC
*************************************************************************************
 
 
FUNCTION LUNESDELPERIODO(X)
*
*Cantidad de Lunes del Periodo
*Autor: CASA MATRIZ
*Fecha de creacin: 20021028
*Ultima actualizacin: 20040106
*------------------------------------------------------------------------------------
local nlunes
nlunes=0
dia=nDesde
do while dia<=nHasta
    IF dow(dia)=2
		nlunes=nlunes+1
	ENDIF
	dia=dia+1
ENDdo
RETURN(nlunes)
ENDFUNC
*************************************************************************************
 
 
FUNCTION LUNESDELMES(X)
*
*Cantidad de lunes del mes al cual pertenece la fecha inicial de un periodo
*Autor: CASA MATRIZ
*Fecha de creacin: 20020629
*Ultima actualizacin: 20040510
*------------------------------------------------------------------------------------
	Local nlunes,dia,fecha_fin,diafinaldelmes
	nlunes=0
	dia=Ctod("01/"+str(Month(nDesde))+"/"+str(year(nDesde)))
	diafinaldelmes=allt(str(UltimoDia(STR(MONTH(dia)),STR(YEAR(dia)))))
	fecha_fin=Ctod(diafinaldelmes+"/"+str(Month(nDesde))+"/"+str(year(nDesde)))
	Do while dia<=fecha_fin
		If dow(dia)=2
			nlunes=nlunes+1
		Endif
		dia=dia+1
	Enddo
	Return(nlunes)


ENDFUNC
*************************************************************************************
 
 
FUNCTION CANTANNOS(X)
*
*Antiguedad del Trabajador
*Autor: CASA MATRIZ
*Fecha de creacin: 20020614
*Ultima actualizacin: 20080814
*------------------------------------------------------------------------------------
if used("trabajad")
	SELECT trabajad
else
	RETURN(0)
endif
SET order to tag cod_trab
SEEK qtrabajadores.cod_trab
IF found()
    ANNOS=CALCULA_ANTIGUEDAD(trabajad.fecha_ing) 
	RETURN(VAL(SUBSTR(ANNOS,1,2)))
ELSE
	GO top
	LOCATE FOR cod_trab = qtrabajadores.cod_trab
	IF found()
	    ANNOS=CALCULA_ANTIGUEDAD(trabajad.fecha_ing)
		RETURN(VAL(SUBSTR(ANNOS,1,2)))	
	else
		RETURN(0)
	endif
ENDIF
ENDFUNC
*************************************************************************************
 
 
FUNCTION TASABCV(fecha_inicio)
*esta parametro contiene el mes y aos necesario para la busqueda
*Interes del mes del BCV
*Autor: CASA MATRIZ
*Fecha de creacin: 20021105
*Ultima actualizacin: 20080814
*------------------------------------------------------------------------------------
ntasa = 0
x = ALLTRIM(STR(MONTH(fecha_inicio)))
cod = PADL(x, 2, "0") + ALLTRIM(STR(YEAR(fecha_inicio)))
SELECT tasa as xtasa from tasasbcv where codigo=cod order by codigo INTO CURSOR qtasa

select qtasa
if !EOF()
	RETURN(qtasa.xtasa)
ELSE
	RETURN(0)
ENDIF
ENDFUNC
*************************************************************************************
 
 
FUNCTION PRESPEND(X)
*
*Calculo de montos pendientes de prestamos personales
*Autor: CASA MATRIZ
*Fecha de creacin: 20080923
*Ultima actualizacin: 20080925
*------------------------------------------------------------------------------------
LOCAL lnSaldoPrestamo

SELECT SUM(saldo_pres) AS saldot FROM prestamo INTO CURSOR saldo WHERE cod_trab = gcCodigoTrabajador GROUP BY cod_trab

SELECT saldo
GO TOP

lnSaldoPrestamo = saldo.saldot

RETURN lnSaldoPrestamo
ENDFUNC
*************************************************************************************
 
 
FUNCTION UTILFRAC(fecha_fin)
*Fecha final
*Das para clculo de fraccin de utilidad
*Autor: CASA MATRIZ
*Fecha de creacin: 20080814
*Ultima actualizacin: 20081029
*------------------------------------------------------------------------------------
LOCAL ldFechaInicio, ldFechaFinal, lnMeses, lnDias, lnTotalDias, lnDiasUtil

ldFechaFinal = fecha_fin

IF gdFechaIngreso < CTOD("01/01/" + TRANSFORM(YEAR(ldFechaFinal), "9999"))
	ldFechaInicio = CTOD("01/01/" + TRANSFORM(YEAR(ldFechaFinal), "9999"))
ELSE
	ldFechaInicio = gdFechaIngreso
ENDIF

lnMeses = INT((ldFechaFinal - ldFechaInicio) / 30)

lnDias = lnMeses * 30

SELECT confpres
lnDiasUtil = diasutil

lnTotalDias = (lnDias * lnDiasUtil) / 360

RETURN lnTotalDias
ENDFUNC
*************************************************************************************
 
 
FUNCTION TOTAPRES(X)
*
*Prestaciones acumuladas
*Autor: CASA MATRIZ
*Fecha de creacin: 20080813
*Ultima actualizacin: 20081031
*------------------------------------------------------------------------------------
LOCAL lnPresAcum, lnAdelPres, lnTotaPres, lnSaldoPrest, lnMeses

*!*	Evaluacin del tiempo de labor en la empresa.
lnMeses = (fecha_fin - gdFechaIngreso) / 30

lnTotaPres = 0
IF lnMeses => 13
	SELECT * FROM trabajad INTO CURSOR curTrabajador WHERE id_nomina = xId_Nomina AND cod_trab = gcCodigoTrabajador
	
	SELECT curTrabajador
	GO TOP
	
	lnSaldoPrest = prestaciones_a
	
	SELECT detapres
	GO TOP
	
	SUM ((suelintpro * acumdias) + (suelprom * diasadic)) FOR id_nomina = xId_Nomina AND cod_trab = gcCodigoTrabajador TO lnPresAcum
	
	SELECT adelpres
	GO TOP
	
	SUM totadpres FOR id_nomina = xId_Nomina AND cod_trab = gcCodigoTrabajador TO lnAdelPres
	
	lnTotaPres = (lnSaldoPrest + lnPresAcum) - lnAdelPres
ENDIF
	
RETURN lnTotaPres
ENDFUNC
*************************************************************************************
 
 
FUNCTION MESANTIG(X)
*
*Clculo de meses de antiguedad en caso de tener el trabajador menos de un ao de labor.
*Autor: CASA MATRIZ
*Fecha de creacin: 20081022
*Ultima actualizacin: 20090122
*------------------------------------------------------------------------------------
LOCAL lnTotaPres, lnMeses

*!*	Evaluacin del tiempo de labor en la empresa.
lnMeses = (fecha_fin - gdFechaIngreso) / 30

lnTotaPres = 0

IF lnMeses < 13
	lnTotaPres = lnMeses
ENDIF

RETURN lnTotaPres
ENDFUNC
*************************************************************************************
 
 
FUNCTION LIQASIGN(nHasta,ncod_trab)
*parametros a evaluar
*Clculo del total de las asignaciones devengadas por el trabajador en la liquidacin.
*Autor: CASA MATRIZ
*Fecha de creacin: 20081105
*Ultima actualizacin: 20131121
*------------------------------------------------------------------------------------
*!*	LOCAL lnTotalAsignaciones

*!*	lnTotalAsignaciones = 0.00

*!*	SELECT curCalculoLiquidacion
*!*	GO TOP

*!*	SUM asignacion FOR !EOF() TO lnTotalAsignaciones

*!*	RETURN lnTotalAsignaciones

LOCAL lnAsignacionesNomina

lnAsignacionesNomina = 0.00 

ldFechaDesde = CTOD("01/01/" + alltr(str(year(nhasta))))
*ldFechaHasta = nhasta
ldFechaHasta = ctod("31/10/2013")

lcWhere = [id_nomina = "] + xId_Nomina + [" AND cod_trab = "] + ncod_trab + [" AND desde >= "] + date2mysql(ldFechaDesde) + [" AND hasta <= "] + date2mysql(ldFechaHasta) + [ " AND tipo_con = 1]+ [ AND estatus = 2]

CargarDatosEnCursor(OdbcMasterConector, "*", "nominas2", lcWhere, "", "nominas2")

&&& calculo de vacaciones
CargarDatosEnCursor(OdbcMasterConector, "*", "nominas2", "1=2", "", "nominas3")

lcWhere = [id_nomina = "] + xId_Nomina + [" AND cod_trab =  "] + ncod_trab + [" AND anno =  "] + ALLTRIM(STR(year(ldFechaHasta))) + [" AND tipoconcepto = "1"] + [ AND codliquidacion ="0001"]

&&lcWhere="id_nomina = " + xId_Nomina + " AND cod_trab = " + ncod_trab + " AND anno = " + ALLTRIM(STR(YEAR(ldFechaHasta)))+""
&&lcWhere=lcWhere+" and codliquidacion=0001 and tipoconcepto=1"

CargarDatosEnCursor(OdbcMasterConector, "*", "liqdetalle", lcWhere, "", "qvacacion")
SELECT qvacacion

SCAN

	SELECT nominas3
	APPEND BLANK
	replace id_nomina WITH qvacacion.id_nomina
	replace cod_trab WITH qvacacion.cod_trab
	replace cod_concep WITH "9999"
	replace tipo_con WITH qvacacion.tipoconcepto			
	replace valor WITH qvacacion.asignacion

	
ENDSCAN

*!*	&&&&&&&& hasta aqui

SELECT * from nominas2 UNION ALL SELECT * from nominas3 INTO CURSOR nominas2
SELECT nominas2
GO TOP

SUM valor FOR cod_trab = nCod_trab AND tipo_con = 1 AND cod_concep<>"3019" and !EOF() TO lnAsignacionesNomina
*SUM valor FOR cod_trab = nCod_trab AND tipo_con = 1 and !EOF() TO lnAsignacionesNomina

RETURN lnAsignacionesNomina

ENDFUNC
*************************************************************************************
 
 
FUNCTION DESPRLEGL(nCod_trab,nDesde,nHasta)
*parametros a evaluar
*total asignaciones para el descanso promedio legal
*Autor: JHONNY
*Fecha de creacin: 20130509
*Ultima actualizacin: 20160415
*------------------------------------------------------------------------------------
LOCAL lnAsignacionesNomina
lnAsignacionesNomina = 0.00
DO CASE
CASE PCOUNT() = 1 && En caso de recibir un solo parmetro desde la llamada de la funcin.
ldFechaDesde = CTOD("01" + SUBSTR(DTOC(nHasta), 3))
ldFechaHasta = GOMONTH(ldFechaDesde, 1) - 1
CASE PCOUNT() = 3 && En caso de recibir el mximo de tres parmetros desde la llamada de la funcin.
	ldFechaDesde = nDesde
ldFechaHasta = nHasta
 OTHERWISE && En caso de recibir un nmero de parmetros diferente a los anteriores.
RETURN lnAsignacionesNomina
ENDCASE

lcWhere1 = [id_nomina = "] + xId_Nomina + [" AND cod_trab = "] + ncod_trab + [" AND desde >= "] + date2mysql(ldFechaDesde) + [" AND hasta <= "] + date2mysql(ldFechaHasta) + [" AND tipo_con = 1]
CargarDatosEnCursor(OdbcMasterConector, "*", "nominas2", lcWhere1, "", "nominas2")

lcWhere2 = [id_nomina = "] + xId_Nomina + [" AND tipo_con = 1 AND va_diades = 1]
CargarDatosEnCursor(OdbcMasterConector, "*", "concepto", lcWhere2, "", "qConc")

SELECT * from nominas2 inner join qConc on nominas2.cod_concep=qConc.cod_concep into cursor nominas2
SELECT nominas2
GO TOP
SUM valor FOR cod_trab = nCod_trab AND !EOF() TO lnAsignacionesNomina

RETURN lnAsignacionesNomina

ENDFUNC
*************************************************************************************
 
FUNCTION ASIGLPH(nCod_trab,nDesde,nHasta)
*Cdigo del trabajador
*Suma de asignaciones para el clculo de LPH
*Autor: CASA MATRIZ
*Fecha de creacin: 20081128
*Ultima actualizacin: 20160415
*------------------------------------------------------------------------------------
*!* Comentario para los usuarios.
*!* Esta funcin est diseada para funcionar de tres maneras posibles, dependiendo de las cantidad de parmetros
*!* que le sean pasados desde el llamado de la funcin.
*!* Si el nmero de parmetros es igual a 1, la funcin asumir que el perodo es correspondiente al mes de
*!* clculo de la nmina, por lo tanto se debe tener cuidado de definirla en el periodo correspondiente.

LOCAL lnAsignacionesNomina

lnAsignacionesNomina = 0.00

DO CASE
	CASE PCOUNT() = 1 && En caso de recibir un solo parmetro desde la llamada de la funcin.
		ldFechaDesde = CTOD("01" + SUBSTR(DTOC(nHasta), 3))
		ldFechaHasta = GOMONTH(ldFechaDesde, 1) - 1
	CASE PCOUNT() = 3 && En caso de recibir el mximo de tres parmetros desde la llamada de la funcin.
		ldFechaDesde = nDesde
		ldFechaHasta = nHasta
 OTHERWISE && En caso de recibir un nmero de parmetros diferente a los anteriores.
		RETURN lnAsignacionesNomina
ENDCASE

lcWhere1 = [id_nomina = "] + xId_Nomina + [" AND cod_trab = "] + ncod_trab + [" AND desde >= "] + date2mysql(ldFechaDesde) + [" AND hasta <= "] + date2mysql(ldFechaHasta) + [" AND tipo_con = 1]
CargarDatosEnCursor(OdbcMasterConector, "*", "nominas2", lcWhere1, "", "nominas2")

lcWhere2 = [id_nomina = "] + xId_Nomina + [" AND tipo_con = 1 AND va_faov = 1]
CargarDatosEnCursor(OdbcMasterConector, "*", "concepto", lcWhere2, "", "qConc")

SELECT nominas2.* from nominas2 inner join qConc on nominas2.cod_concep=qConc.cod_concep into cursor nominas2
GO TOP

SUM valor FOR cod_trab = nCod_trab AND !EOF() TO lnAsignacionesNomina

RETURN lnAsignacionesNomina
ENDFUNC
*************************************************************************************
 
*************************************************************************************
FUNCTION TotalAsignacion(nCod_trab, fDesde, fHasta, pConcepto)
*Cdigo del trabajador
*Suma de asignaciones por pago de nomina para un periodo determinado
*Autor: Edgar I. Sanchez M.
*Fecha de creacin: 2019.03.15
*------------------------------------------------------------------------------------
LOCAL lnAsignacionesNomina

	lnAsignacionesNomina = 0.00
	
	do case
		case pcount() = 3
			ldFechaDesde = fdesde
			ldFechaHasta = fhasta

		case pcount() = 4
			ldFechaDesde 	= fdesde
			ldFechaHasta 	= fhasta
			lcConcepto 		= alltrim(pConcepto)
		otherwise
			MESSAGEBOX("Faltan Datos en la Funcion")
			RETURN 0
	endcase

	if type("lcConcepto") = 'L'
		lcConcepto = ""
	endif

	lcWhere = [id_nomina = "] + xid_nomina + [" and ] + ;
	          [cod_trab = "] + ncod_trab + [" and ] + ;
	          [desde >= "] + date2mysql(ldfechadesde) + [" and ]+;
	          [hasta <= "] + date2mysql(ldfechahasta) + [" and tipo_con = "1" ]

	if !empty(lcConcepto)
		lcWhere = lcWhere + [ and cod_concep <> "] + lcConcepto + [" ]
	endif      

	CargarDatosEnCursor(OdbcMasterConector, "*", "nominas2", lcWhere, "", "nominas2")
	SELECT nominas2
	GO TOP
	SUM valor TO lnAsignacionesNomina
	RETURN lnAsignacionesNomina
ENDFUNC
*************************************************************************************

FUNCTION TotalDeducciones(nCod_trab, fDesde, fHasta, pConcepto)
*Cdigo del trabajador
*Suma de asignaciones por pago de nomina para un periodo determinado
*Autor: Edgar I. Sanchez M.
*Fecha de creacin: 2019.03.15
*------------------------------------------------------------------------------------
LOCAL lnAsignacionesNomina

	lnAsignacionesNomina = 0.00
	
	do case
		case pcount() = 3
			ldFechaDesde = fdesde
			ldFechaHasta = fhasta

		case pcount() = 4
			ldFechaDesde 	= fdesde
			ldFechaHasta 	= fhasta
			lcConcepto 		= alltrim(pConcepto)
		otherwise
			MESSAGEBOX("Faltan Datos en la Funcion")
			RETURN 0
	endcase

	if type("lcConcepto") = 'L'
		lcConcepto = ""
	endif

	lcWhere = [id_nomina = "] + xid_nomina + [" and ] + ;
	          [cod_trab = "] + ncod_trab + [" and ] + ;
	          [desde >= "] + date2mysql(ldfechadesde) + [" and ]+;
	          [hasta <= "] + date2mysql(ldfechahasta) + [" and tipo_con = "2" ]

	if !empty(lcConcepto)
		lcWhere = lcWhere + [ and cod_concep <> ["] + lcConcepto + [" ]
	endif      

	CargarDatosEnCursor(OdbcMasterConector, "*", "nominas2", lcWhere, "", "nominas2")
	SELECT nominas2
	GO TOP
	SUM valor TO lnAsignacionesNomina
	RETURN lnAsignacionesNomina
ENDFUNC
*************************************************************************************

FUNCTION TotalDeduccion(nCod_trab, fDesde, fHasta, pVacaciones, pLiquidaciones, pDecimoTercerMes)
*Cdigo del trabajador
*Suma de Deducciones por pago de nomina para un periodo determinado
*Autor: Edgar I. Sanchez M.
*Fecha de creacin: 2019.03.15
*------------------------------------------------------------------------------------
LOCAL lnDeduccionesNomina

	if type("pVacaciones") = 'L'
		pVacaciones = 2
	endif
	if type("pLiquidaciones") = 'L'
		pLiquidaciones = 2
	endif
	if type("pDecimoTercerMes") = 'L'
		pDecimoTercerMes = 2
	endif

	mlCondicion = ''
	
	if pVacaciones = 1
		mlCondicion = mlCondicion + " (va_vacacio = '1' "
	endif
	if pLiquidaciones = 1
		if !empty(mlCondicion)
			mlCondicion = mlCondicion + " or va_liquid = '1' "
		else
			mlCondicion = mlCondicion + " (va_liquid = '1' "
		endif
	endif
	if pDecimoTercerMes = 1
		if !empty(mlCondicion)
			mlCondicion = mlCondicion + " or aplica3mes = '1' "
		else
			mlCondicion = mlCondicion + " (aplica3mes = '1' "
		endif			
	endif

	if !empty(mlCondicion)
		mlCondicion = "and " + alltrim(mlCondicion) + ") "
	endif

	lnDeduccionesNomina = 0.00
	
		if PCOUNT() >= 3 
			ldFechaDesde = fdesde
			ldFechaHasta = fhasta
		ELSE
			MESSAGEBOX("Faltan Datos en la Funcion")
			RETURN 0
		ENDIF

	lcWhere = [nominas2.id_nomina = "] + xid_nomina + [" and ] + ;
	          [nominas2.cod_trab = "] + ncod_trab + [" and ] + ;
	          [nominas2.desde >= "] + date2mysql(ldfechadesde) + [" and ]+;
	          [nominas2.hasta <= "] + date2mysql(ldfechahasta) + [" and nominas2.tipo_con = "2" ]
	lcWhere = lcWhere + mlCondicion
	
	lcJoin = " left join concepto on (nominas2.cod_concep = concepto.cod_concep and nominas2.id_nomina = concepto.id_nomina) "
	
	&& 2019.03.15 EISM
	&& TIPO_CON es 1 cuando es asignacion, 2 cuando es deduccion
	
	CargarDatosEnCursor(OdbcMasterConector, "nominas2.*", "nominas2 " + lcJoin, lcWhere, "", "nominas2")
	SELECT nominas2
	GO TOP
	SUM valor TO lnDeduccionesNomina
	RETURN lnDeduccionesNomina
ENDFUNC
*************************************************************************************

